SystemOrganization addCategory: #'SourceCity-Test'!

TestCase subclass: #SourceCityCoreTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Test'!

!SourceCityCoreTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/20/2012 15:54'!
buildingTest
"self debug: #buildingTest"
	| building |
	building := Building named: 'Test' inDistrict: (District named: 'District' inCity: (City named: 'City') ) dimension: (Point3D x: 0 y: 0 z: 0) color: (Color red) dependencies: OrderedCollection new.
	
	self assert: building isBuilding.
	self assert: building name = 'Test'.
	self assert: building dependencies size = 0.
	self assert: building district name = 'District'.
	self assert: building color = (Color red).! !

!SourceCityCoreTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/20/2012 15:58'!
cityTest
"self debug: #cityTest"
	| city |
	city := City named: 'Test'.
	city add: 'a'.
	
	self assert: city isCity.
	self assert: city name = 'Test'.
	self assert: city dependencies size = 0.
	self assert: city districts size = 1.
	city add: 'b'.
	self assert: city districts size = 2.
	self assert: city color = (Color r: 0.6 g: 0.6 b: 0.6).! !

!SourceCityCoreTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/20/2012 15:56'!
districtTest
"self debug: #districtTest"
	| district |
	district := District named: 'Test' inCity: (City named: 'City').
	district add: 'a'.
	
	self assert: district isDistrict.
	self assert: district name = 'Test'.
	self assert: district dependencies size = 0.
	self assert: district buildings size = 1.
	self assert: district city name = 'City'.
	self assert: district color = (Color r: 0.8 g: 0.8 b:0.8).
	district add: 'b'.
	self assert: district buildings size = 2.! !

TestCase subclass: #SourceCityImporterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Test'!

!SourceCityImporterTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/29/2012 14:50'!
sourceCityImporterTest
"self debug: #sourceCityImporterTest"
	| import |
	"do not change anything at SourceCityImporterRPackageStrategy else this test should fail"
	import := (SourceCityImporter title: 'test' 
		strategy: SourceCityImporterRPackageStrategy 
		new import: #('SourceCity-Test' ) ).
	
	self assert: import city name = 'test'.
	self assert: import city districts size = 1.
	self assert: (import city districts at: 1) buildings size = (RPackageOrganizer default packageNamed: 'SourceCity-Test') classes size! !

TestCase subclass: #SourceCityLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Test'!

!SourceCityLayoutTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/21/2012 11:19'!
sourceCitySquareLayoutNodeTest
"self debug: #sourceCitySquareLayoutNodeTest"
	| node city |
	node := SourceCitySquareLayoutNode gap: 2.
	node rectangle: (Rectangle origin: (Point x: 0 y: 0) corner: (Point x: 10 y: 10) ).
	city  := City named: 'Test'. 
	city dimension: (Point3D x: 5 y: 0 z: 5).
	
	self assert:  node gap = 2.
	self assert: node isFree.
	self assert: node isLeaf.
	self assert: (node isAnyFitFor: city).
	
	city dimension: (Point3D x: 10 y: 0 z: 10).
	self assert: (node isPerfectFitFor: city).
	! !

!SourceCityLayoutTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/21/2012 12:56'!
sourceCitySquareLayoutTreeTest
"self debug: #sourceCitySquareLayoutTreeTest"
	| tree node |
	node := SourceCitySquareLayoutNode gap: 2.
	tree := SourceCitySquareLayoutTree newRoot: (node) gap: 2.
	
"	self assert:  tree gap = 2.
	self assert: tree isFree.
	self assert: tree isLeaf.
	self assert: (node isAnyFitFor: city)."
	! !

TestCase subclass: #SourceCityOpenGLTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Test'!

!SourceCityOpenGLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/29/2012 13:30'!
sourceCityPoint3DTest
"self debug: #sourceCityPoint3DTest"
	| point |
	point := Point3D x: 0 y: 10 z: -10.
	
	self assert:  point x = 0.
	self assert:  point y = 10.
	self assert:  point z = -10.! !

TestCase subclass: #SourceCityToolsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Test'!

!SourceCityToolsTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/20/2012 16:06'!
sourceCityCameraTest
"self debug: #sourceCityCameraTest"
	| camera |
	camera := SourceCityCamera position: (Point3D x: 0 y: 0 z: 0) orientation: (Point3D x: 0 y: 0 z: 0).
	
	self assert:  camera position = (Point3D x: 0 y: 0 z: 0).
	self assert: camera orientation = (Point3D x: 0 y: 0 z: 0).! !

!SourceCityToolsTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/29/2012 13:23'!
sourceCityConfigurationTest
"self debug: #sourceCityConfigurationTest"
	| config city camera |
	city := City named: 'test'.
	city dimension: (Point3D x: 0 y: 0 z: 0). 
	camera := SourceCityCamera position: (Point3D x: 0 y: 0 z: 0) orientation: (Point3D x: 0 y: 0 z: 0).
	config := SourceCityConfiguration new.
	config city: city.
	config camera: camera.
	"set new camera because there is some calcul includes city dimension, so i set everything to 0 calcul is just about how to have a correct rendering about City"
	
	self assert: config camera position = (Point3D x: 0 y: 0 z: 0).
	self assert: config camera orientation = (Point3D x: 0 y: 0 z: 0).
	self assert: config city name = 'test'.
	self assert: config backgroundOpenGL = Color white.
	! !
